capture program drop e_val

*! version 1.0.0 4/9/97 - expected values for poisson and nbreg
* e_val: computes expected values without computing probabilities.
* Used by: change
* Requires: S_1 with values of independent variables
* Returns: S_1 with predicted value exp(x*b) for poisson and negative binomial

program define e_val
    version 4.0
    tempvar b x o xb sxb 
    mat `b' = get(_b)
    if "$S_E_cmd"=="nbreg" {
        local nb = colsof(`b') - 1 /* -1 for alpha */        
        mat `b' = `b'[1,1..`nb']
    }
    mat `x' = S_1  /* assumes values of x in S_1 */
    mat S_1 = J(1,1,1)
    if "$S_E_cmd"=="nbreg" | "$S_E_cmd"=="poisson" {
        local nb = colsof(`b')
        mat `o'= J(1,1,1)
        mat `x' = `x',`o'
        mat `xb' = `x' * `b''
        scalar `sxb' = exp(`xb'[1,1])
        mat S_1[1,1] = `sxb'
        mat colnames S_1 = exp(xb)
    }
end

