capture program drop getdesc
* allow if and in   
*! version 1.1.2 4/11/97 - use getrhs
* version 1.1.1 4/6/97 - add poisson, regress, nbreg
* version 1.1.0 9/5/96
* -getdesc- gets desc stats for lhs & rhs variables.

program define getdesc
    version 4.0
    tempvar b tmp
	local if "opt"
	local in "opt"
    parse "`*'"

* get estimates and start decoding names
    mat `b' = get(_b)
    if "$S_E_cmd"=="nbreg" {
        local nb = colsof(`b') - 1 /* -1 for alpha */        
        mat `b' = `b'[1,1..`nb']
    }
    local nvars = colsof(`b')

* determine # of categories if ordered regression model
    if "$S_E_cmd"=="oprobit" | "$S_E_cmd"=="ologit" {
        local ncats 1
        capture local j=_b[_cut`ncats']
        while _rc==0 {
            local ncats=`ncats'+1
            capture local j=_b[_cut`ncats']
        }
        local nvars = `nvars' - `ncats' + 2 /* #x + 1 for lhs var */
    }

* get names of variables
    getrhs
    local rhsnam "$S_1"

* start getting desc stats and saving them
    mat S_1 = J(1,`nvars',1) /* for mean */
    mat S_2 = J(1,`nvars',1) /* for SD */
    mat S_3 = J(1,`nvars',1) /* for min */
    mat S_4 = J(1,`nvars',1) /* for max */
    mat colnames S_1 = $S_E_depv `rhsnam'
    mat colnames S_2 = $S_E_depv `rhsnam'
    mat colnames S_3 = $S_E_depv `rhsnam'
    mat colnames S_4 = $S_E_depv `rhsnam'

* get data on lhs variable
    quietly sum $S_E_depv `if' `in'
    mat S_1[1,1] = _result(3)
    scalar `tmp' = sqrt(_result(4))
    mat S_2[1,1] = `tmp'
    mat S_3[1,1] = _result(5)
    mat S_4[1,1] = _result(6)

* loop through rhs variables
    local nvars = `nvars' - 1
    local i = 1
    while `i'<=`nvars' {
        local nmtoget : word `i' of `rhsnam'
        quietly sum `nmtoget' `if' `in'
        local i=`i'+1
        mat S_1[1,`i'] = _result(3)
        scalar `tmp' = sqrt(_result(4))
        mat S_2[1,`i'] = `tmp'
        mat S_3[1,`i'] = _result(5)
        mat S_4[1,`i'] = _result(6)
    }
end

