capture program drop getrhs
*! version 1.0.1 6/17/97 - add tobit and return S_2
*! version 1.0.0 4/11/97
* Run after regression models.
* Returns: S_1 with names of RHS variables. S_2 with number
* Works for: regress, logit, probit, ologit, oprobit, poisson, nbreg, mlogit
* and tobit. Inspired by code in lfit
program define getrhs
	version 5.0
	local beta "`1'"
	if "`beta'" == "" {
		tempname beta
		matrix `beta' = get(_b)
	}
	local ivars : colnames(`beta')
	local nvar  : word count `ivars'
	parse "`ivars'", parse(" ")
	if ("$S_E_cmd"=="nbreg") { /* strip off two constants at end */
		local ivars "`1'"
		local i 2
		while "``i''" != "" {
			if "``i''" != "_cons" {
				local ivars "`ivars' ``i''"
			}
			local i = `i' + 1
		}
    }
	else if "``nvar''" == "_cons" { /* look at last element */
		local `nvar'       /* erase last macro */
		local ivars "`*'"
	}
	else if "$S_E_cmd"=="tobit" {
		local ivars "`1'"
		local i 2
		while "``i''" != "_cons" {
    		local ivars "`ivars' ``i''"
			local i = `i' + 1
		}
	}	
	else if "`1'" == "_cons" { /* look at first element */
		macro shift
		local ivars "`*'"
	}
	else if ("$S_E_cmd"!="ologit" | "$S_E_cmd"!="oprobit") {
		local ivars "`1'"
		local i 2
		while "``i''" != "" {
			if substr("``i''",1,4) != "_cut" {
				local ivars "`ivars' ``i''"
			}
			local i = `i' + 1
		}
	}

/*
	else if {             else if ("$S_E_cmd"!="mlogit") {
	}
*/

	else { /* step through elements to capture "_cons" */
		local ivars "`1'"
		local i 2
		while "``i''" != "" {
			if "``i''" != "_cons" {
				local ivars "`ivars' ``i''"
			}
			local i = `i' + 1
		}
	}

	global S_1 "`ivars'"
*   di "RHS: $S_1"
	local nvar  : word count `ivars'
	global S_2 "`nvar'"
*   di "NVAR: $S_2"
end

