*! version 1.1.6 jsl 6/15/97
capture program drop liststd

program define liststd
    version 4.0

    if ("$S_E_cmd"!="poisson" & "$S_E_cmd"!="regress" /*
    */ & "$S_E_cmd"!="logit" & "$S_E_cmd"!="probit" /*
    */ & "$S_E_cmd"!="ologit" & "$S_E_cmd"!="oprobit" /*
    */ & "$S_E_cmd"!="nbreg" & "$S_E_cmd"!="mlogit" /*
    */ & "$S_E_cmd"!="tobit"/*
    */ ) {
        di
di in r "-liststd- must be run after poisson, nbreg, logit, probit, ologit,
di in r "oprobit,regress, or tobit."
        exit
    }

    if "$S_E_cmd"=="mlogit" {
        di
        di in r "Use " in y "listodds" in r " for mlogit."
        exit
    }

* get info about b's
    tempvar b sdb factor vx sdy bnocon vare one bs bsx bsy tval
    tempvar bout btmp sdystar lnalpha talpha
    mat def `b' = get(_b)
    local nb = colsof(`b')
    mat def `sdb' = get(VCE)
    mat `sdb' = vecdiag(`sdb')

* determine # of categories if ordered regression model
    if "$S_E_cmd"=="oprobit" | "$S_E_cmd"=="ologit" {
	    local ncats 1
    	capture local j=_b[_cut`ncats']
	    while _rc==0 {
		    local ncats=`ncats'+1
    		capture local j=_b[_cut`ncats']
	    }
        local nbm1 = colsof(`b') - `ncats'
        local nbm1 = `nbm1' + 1
    }


* strip off names of _con and _cut
    getrhs
    local rhsnam "$S_1"

* number of betas
    if "$S_E_cmd"=="logit" | "$S_E_cmd"=="probit" /*
        */ | "$S_E_cmd"=="regress" /*
        */ | "$S_E_cmd"=="poisson" {
        local nbm1 = colsof(`b') - 1
    }
    if "$S_E_cmd"=="tobit" | "$S_E_cmd"=="nbreg" {
        local nbm1 = colsof(`b') - 2
    }

* get cov matrix of observed variables
    scalar `factor' = 1/(_result(1)-1)  /* 1 over nobs - 1 */
    quietly mat accum `vx' = $S_E_depv `rhsnam', /*
        */ deviations noconstant `if' `in'

    /* sd of observed y */
    scalar `sdy' = sqrt(`factor' * `vx'[1,1])
    di " "    
    di in gr "Unstandardized and Standardized Estimates"
    di " "
    di in gr "   Procedure: " in y "$S_E_cmd"
    di in gr "LHS variable: " in y "$S_E_depv"
    di in gr " Observed SD: " in y `sdy'
    mat `vx' = `vx'[2...,2...] /* trim off lhs variable */
    mat `vx' = `factor' * `vx' /* cov matrix of rhs vars */

* compute sd of ystar
    mat def `bnocon' = `b'[1,1..`nbm1'] /* trim off _con */

    if "$S_E_cmd"=="probit" | "$S_E_cmd"=="logit" /*
        */  | "$S_E_cmd"=="oprobit" | "$S_E_cmd"=="ologit" /*
        */  | "$S_E_cmd"=="tobit" {

        mat def `sdystar' = `bnocon' * `vx'
        mat `sdystar' = `sdystar' * `bnocon''
        /* probit assumes variance of 1 */
        mat `vare' = J(1,1,1)
        scalar `factor' = 1
        if "$S_E_cmd"=="logit" | "$S_E_cmd"=="ologit" {
            scalar `factor' = (_pi*_pi)/3
        }
        if "$S_E_cmd"=="tobit" {
            scalar `factor' = `b'[1,`nb']*`b'[1,`nb']
        }
        mat `vare' = `factor' * `vare'
        mat `sdystar' = `sdystar' + `vare'
        scalar `sdy' = sqrt(`sdystar'[1,1])
        di in g "   Latent SD: " in y `sdy'
    }
    mat `vx' = vecdiag(`vx') /* contains variances of x's */
    local nx = colsof(`vx')

* compute standardized coefficients
* - dummy up matrices
    mat def `bsy' = `bnocon'
    mat def `bsx' = `bsy'
    mat def `bs' = `bsy'
    mat def `tval' = `bsy'
* y standardized betas    
    scalar `factor' = 1/`sdy'
    mat `bsy' = `factor' * `bsy'
    
    if "$S_E_cmd"=="nbreg" {
        sca `lnalpha' = `b'[1,`nb']
        sca `talpha' = `lnalpha'/sqrt(`sdb'[1,`nb'])
        di " Observed SD: " `sdy'
        di " ln alpha:    " `lnalpha' "  z=" %7.3f `talpha'
    }
    
    local i = 1
    while `i'<=`nx' {
        mat `vx'[1,`i']   = sqrt(`vx'[1,`i']) /* compute sd of x's */
        mat `sdb'[1,`i']  = sqrt(`sdb'[1,`i']) /* sd of b's */
        mat `bsx'[1,`i']  = `bsx'[1,`i']*`vx'[1,`i'] /* b*sd(x) */
        mat `bs'[1,`i']   = `bsy'[1,`i']*`vx'[1,`i'] /* b*sd(x)/sd(y) */
        mat `tval'[1,`i'] = `tval'[1,`i']/`sdb'[1,`i'] /* t of b */
       local i=`i'+1
    }
    mat `bout' = `bnocon''
    if "$S_E_cmd"=="poisson" | "$S_E_cmd"=="nbreg" {
        local i = 1
        while `i'<=`nx' {
            mat `bs'[1,`i']   = exp(`bnocon'[1,`i']) /* exp(b) */
            mat `bsx'[1,`i']  = exp(`bsx'[1,`i'])    /* exp(b*SdX) */
            local i=`i'+1
        }
        mat `btmp' = `bs''
        mat `bout' = `bout',`btmp'
    }        
    else {
        mat `btmp' = `bs''
        mat `bout' = `bout',`btmp'
        mat `btmp' = `bsy''
        mat `bout' = `bout',`btmp'
    }        
    if "$S_E_cmd"=="regress" | "$S_E_cmd"=="tobit" | /*
    */ "$S_E_cmd"=="poisson" | "$S_E_cmd"=="nbreg" {
        mat `btmp' = `bsx''
        mat `bout' = `bout',`btmp'
    }
    mat `btmp' = `tval''
    mat `bout' = `bout',`btmp'
    mat `btmp' = `vx''
    mat `bout' = `bout',`btmp'
    mat colnames `bout' = b bStdXY bStdY z SDofX
    if "$S_E_cmd"=="regress" | "$S_E_cmd"=="tobit" {
        mat colnames `bout' = b bStdXY bStdY bStdX z SDofX
    }
    if "$S_E_cmd"=="poisson" | "$S_E_cmd"=="nbreg" {
        mat colnames `bout' = b e^b e^bStdX z StdDevX
    }
    mat roweq `bout' = _
    mat list `bout',noheader f(%8.0g)
end

