capture program drop m_val
*! version 1.0.3 4/9/97 - revise for mlogit
* version 1.0.3 4/9/97 - change sign for ologit and oprobit
* version 1.0.2 4/9/97 - poisson and nbreg
* version 1.0.1 9/4/96
* Used by:   -change-
* Returns:   S_1 contains marginals
* Works for: logit, probit, mlogit, ologit, oprobit, poisson, nbreg
*
* DO: error if not following valid S_E_cmd
* DO: clean code -- some is probalby not needed for
* marginals, but is left over from computing probs
* Compute marginal change in predicated values

program define m_val
    version 4.0
    tempvar b x o xb sxb prob marg tmp bxb bxbm1 difpdf tmp2
    mat `b' = get(_b)
    if "$S_E_cmd"=="nbreg" {
        local nb = colsof(`b') - 1 /* -1 for alpha */
        mat `b' = `b'[1,1..`nb']
    }
    mat `x' = S_1

* binary logit, probit, poisson, nbreg
    if "$S_E_cmd"=="logit" | "$S_E_cmd"=="probit" /*
    */ | "$S_E_cmd"=="poisson" | "$S_E_cmd"=="nbreg" {
        mat `o'= J(1,1,1)
        mat `x' = `x',`o'
        mat `xb' = `x' * `b''
        local nb = colsof(`b') - 1
        mat `b' = `b'[1,1..`nb'] /* get rid of _con */
        scalar `sxb' = `xb'[1,1]
        if "$S_E_cmd"=="logit" {
            scalar `prob' = exp(`sxb')/(1+exp(`sxb'))
            scalar `tmp' = `prob'*(1-`prob')
            mat `marg' = `tmp'*`b'
        }
        else if "$S_E_cmd"=="probit" {
            scalar `prob' = normprob(`sxb')
            scalar `tmp'  = exp(-`sxb'*`sxb'/2)/sqrt(2*_pi)
            mat `marg' = `tmp'*`b'
        }
        else if "$S_E_cmd"=="poisson" | "$S_E_cmd"=="nbreg" {
            scalar `prob' = exp(`sxb')
            mat `marg' = `prob'*`b'
            scalar `prob' = -exp(`sxb') /* to undo change below */
        }
        mat `prob' = -1 * `marg' /* marg wrt 0 */
        mat S_1 = `prob' \ `marg'
    }

    if "$S_E_cmd"=="oprobit" | "$S_E_cmd"=="ologit" {
        * determine ncats
        local ncats 1
        capture local j=_b[_cut`ncats']
        while _rc==0 {
            local ncats=`ncats'+1
            capture local j=_b[_cut`ncats']
        }
    * compute xb without intercept
        mat `b' = get(_b)
        local nb = colsof(`b') - `ncats'
        local nb = `nb' + 1
        mat `b' = `b'[1,1..`nb'] /* get rid of _con's */
        mat `x' = S_1
        mat `xb' = `x' * `b''
        scalar `sxb' = `xb'[1,1]
        mat `difpdf' = J(1,`ncats',1)
        mat `marg' = J(`nb',`ncats',1)
    * compute probabilities
        if "$S_E_cmd"=="oprobit" {
            mat `prob' = J(1,`ncats',1)
            scalar `bxb' = _b[_cut1]-`sxb'
            scalar `tmp' = normprob(`bxb') /* prob for cat 1 */
            mat `prob'[1,1] = `tmp'
            scalar `tmp'  = exp(-`bxb'*`bxb'/2)/sqrt(2*_pi)
            mat `difpdf'[1,1] = `tmp'
            local i 2
            while `i'<`ncats' {
                local im1=`i'-1
                scalar `bxb' = _b[_cut`i']-`sxb'
                scalar `bxbm1' = _b[_cut`im1']-`sxb'
                scalar `tmp' = normprob(`bxb') - normprob(`bxbm1')
                mat `prob'[1,`i'] = `tmp'
                scalar `tmp'  = exp(-`bxb'*`bxb'/2)/sqrt(2*_pi)
                   scalar `tmp'  = `tmp' - exp(-`bxbm1'*`bxbm1'/2)/sqrt(2*_pi)
                mat `difpdf'[1,`i'] = `tmp'
                local i=`i'+1
            }
            local im1=`i'-1
            scalar `bxb' = `sxb'-_b[_cut`im1']
            scalar `tmp' = normprob(`bxb')
            mat `prob'[1,`ncats'] = `tmp'
            scalar `tmp' = exp(-`bxb'*`bxb'/2)/sqrt(2*_pi)
            mat `difpdf'[1,`ncats'] = `tmp'
        }
        if "$S_E_cmd"=="ologit" {
            mat `prob' = J(1,`ncats',1)
            scalar `tmp' = 1/(1+exp(`sxb'-_b[_cut1]))
            mat `prob'[1,1] = `tmp'
            mat `difpdf'[1,1] = `tmp'*(1-`tmp')
            local i 2
            while `i'<`ncats' {
                local im1=`i'-1
                scalar `tmp' = 1/(1+exp(`sxb'-_b[_cut`i']))
                scalar `tmp2' = 1/(1+exp(`sxb'-_b[_cut`im1']))
                mat `prob'[1,`i'] = `tmp' - `tmp2'
                mat `difpdf'[1,`i'] = (`tmp'*(1-`tmp')) - (`tmp2'*(1-`tmp2'))
                local i=`i'+1
            }
            local im1=`i'-1
            scalar `tmp' = 1/(1+exp(`sxb'-_b[_cut`im1']))
            mat `prob'[1,`ncats'] = 1-`tmp'
            mat `difpdf'[1,`i'] = - (`tmp'*(1-`tmp'))
        }
        local i 1
        while `i'<=`nb' {
            local j 1
            while `j'<=`ncats' {
                mat `marg'[`i',`j'] = `difpdf'[1,`j'] * `b'[1,`i']
                local j = `j' + 1
            }
            local i = `i' + 1
        }
        mat S_1 = `marg'*-1
    }

    if "$S_E_cmd"=="mlogit" {
    * get expected probabilities
        tempvar pdiag sumpb o
        getdesc
        mat S_1 = S_1[1,2...]
        p_val
        mat `pdiag' = diag(S_2)
        local ncat = rowsof(`b') + 1
        local nb = colsof(`b')
        mat `o' = J(1,`nb',0)
        mat `b' = `b' \ `o' /* add 0's for last outcome */
        mat `marg' = `pdiag'*`b'
        mat `o' = J(`ncat',`ncat',1)
        mat `marg' = `o'*`marg'
        mat `marg' = `b' - `marg'
        mat `marg' = `pdiag' * `marg'
        local nb = colsof(`b')-1
        mat S_1 = `marg'[.,1..`nb']
        mat S_1 = S_1'
    }
end

